// stepper.h

#ifndef CMD_H
#define CMD_H
#include <arduino.h>
#include <Wire.h>

// Definieren der Variablen zur Buffersteuerung mit Startwerten
#define STRLEN   100
#define MAXCMD   5
#define WORDCNT  4
#define WORDLEN  5

struct COMMAND
{
  char keyword;
  int parameter;
};

//Klasse der Komandoschnittstelle
class CmdInterface
{
  private:
    char cmdBuffer[STRLEN + 1];              // Speicher für die Befehlszeichen einer Zeile
    char cmdWord[WORDCNT + 1][WORDLEN + 1];  // Speicher für die einzelnen Befehlesworte
    unsigned int bufferCtr;                 // Zähler für Zeichenbuffer
    COMMAND input;                          // Packet für die Befehlsübergabe
    
 private:
   bool CompareString(char *a, char* b) const; // Vergleichen der eingegangenen Zeichen mit definierten Befehlen 
   int ToInteger(char* a); // Umwandlung einer Zeichenkette zu einem Zahlenwert
  public:
    CmdInterface(); // Standardkonstruktor                  
    void Init(unsigned int baudrate);  //Baudrate setzen
    bool IsCommandAvailable();         // Abfrage ob ein Befehl vorhanden ist 
    COMMAND GetCommand(); // Befehl anfordern
    void DecodeCommand(); // Befehle aus Zeichenbuffer extrahieren
};
#endif
