// stepper.cpp

// simple stepper driver class

#include "StepperV1.h"

StepperV1::StepperV1(int Step_Pin, int Dir_Pin, int Enable_Pin)
{
  // Setzen der Treiber-Pins für ein Objekt von Stepper
  this->Step_Pin = Step_Pin;
  this->Dir_Pin = Dir_Pin;
  this->Enable_Pin = Enable_Pin;

  // Setzen der Treiber-Pins zur Ansteuerung auf Output
  pinMode(Step_Pin, OUTPUT);
  pinMode(Dir_Pin, OUTPUT);
  pinMode(Enable_Pin, OUTPUT);

//  SetEnable(ENABLED); // Freigabe am Treiber
//
//  SetDirection(FORWARD); // Drehrichtung auf Standardwert

  //SetSteps(16,200); // Schritte pro Umdrehung auf Standardwert
  //SetSpeed(0);     // Drehgeschwindigkeit auf Standardwert
}

StepperV1::StepperV1(int Step_Pin, int Dir_Pin, int Enable_Pin, int Speed, bool Direction)
{
  // Setzen der Treiber-Pins
  this->Step_Pin = Step_Pin;
  this->Dir_Pin = Dir_Pin;
  this->Enable_Pin = Enable_Pin;

  // Setzen der Pins auf Output
  pinMode(Step_Pin, OUTPUT);
  pinMode(Dir_Pin, OUTPUT);
  pinMode(Enable_Pin, OUTPUT);

//  SetEnable(ENABLED); // Freigabe am Treiber
//
//  SetDirection(Direction); // Drehrichtung vorgeben

  //SetSteps(16, 200); // Schrittzahl pro Umdrehung einstellen
  //SetSpeed(Speed); // Drehgeschwindigkeit vorgeben
}

//void StepperV1::SetSpeed(unsigned int Speed)
//{
//  // Berechnen der Ansteuerungsdauer für Step_Pin in Mikrosekunden 
//  Duration = (60L * 1000 * 1000) / (NumberSteps * 2 * (long)Speed);
//}

//void StepperV1::Run(StepperV1* Stepper2)
//{
//  // Motore werden durch Taktung von Set_Pin mit der vorgegebenen Drehzahl betrieben 
//  this -> SetStepPin(HIGH);
//  Stepper2->SetStepPin(HIGH);
//  delayMicroseconds(Duration);
//  this->SetStepPin(LOW);
//  Stepper2 -> SetStepPin(LOW);
//  delayMicroseconds(Duration);
//}

//void StepperV1::SetSteps(int stepsize, int vollsteps)
//{
//  // Berechnen der Anzahl von Schritten pro Umdrehung
//  NumberSteps = stepsize * vollsteps;
//}

void StepperV1::SetEnable(bool Enable)
{
  // Sperren und Freigeben des Treibers  
  //this->Enable = Enable;
  digitalWrite(Enable_Pin, Enable);
}

//bool StepperV1::GetEnable()
//{
//  // Rückmeldung über den Freigabezustand  
//  return Enable;
//}

void StepperV1::SetDirection(bool Direction)
{
  // Setzen der Drehrichtung
  digitalWrite(Dir_Pin, Direction);
//  this->Direction = Direction;
}

//bool StepperV1::GetDirection()
//{
//  // Rückgabe der Drehrichtung
//  return Direction;
//}

//int StepperV1::GetDuration()
//{
//  // Rückgabe der Wartezeit am Step_Pin 
//  return Duration;
//}

void StepperV1::SetStepPin(bool EN)
{
  // Setzen des Step_Pin zur Taktung und Bestromung
  // Aufruf in der Run-Funktion
  digitalWrite(Step_Pin, EN);
}

// void StepperV1::SwitchDirection()
// {
//   Direction = !Direction;
// }
 
// void SetSteps(int stepsize = 16, int vollsteps = 200)
// {
//    // Berechnen der Anzahl von Schritten pro Umdrehung
//    NumberSteps = stepsize * vollsteps;
// }

