#include "Umwandlungsroutinen.h"
#include "defines.h"
using namespace std;

unsigned int PotiToSpeed(unsigned int poti)
{
	return SPS_LOW + (unsigned int)(((SPS_MAX - SPS_LOW)*(unsigned long)poti) >> 10);
}

unsigned int CmdToSpeed(struct COMMAND cmd)
{
	// Ignorieren von Gro�-Klein-Schreibung
	char key = cmd.keyword & 0xDF;

	switch (key)
	{
		case KEY_ROT:
			return RotPerSecToSpeed(cmd.parameter);

		case KEY_FLOW:
			return FlowPerSecToSpeed(cmd.parameter);

		case KEY_STOP:
			return StopSpeed();

		default:
			return 0;
	}

	return 0;
}

unsigned int RotPerSecToSpeed(unsigned int rot)
{

	return PPS*RES*(unsigned int)rot;
}

unsigned int FlowPerSecToSpeed(unsigned int flow)
{
	return RotPerSecToSpeed(flow / Vg);	
}	


unsigned int StopSpeed()
{
	return 0;
}
