#ifndef DEFINES_H
#define DEFINES_H

#define ENABLED    LOW
#define FORWARD    LOW

#define CPU              16000000     // 16 MHz
#define PPS              8            // 8tel Schritte // parts per step
#define RES              400          // 0.9° Auflösung
#define SPS_MIN          PPS*RES/PPS   // [sps] = 320 (0.1/s) step pulses/s für minimale Drehzahl                       // 400
#define SPS_MAX          6*PPS*RES    // [sps] (7/s) step pulses/s maximale Drehzahl                                    // 19200
//#define SPS_MAX          8*PPS*RES    // [sps] (7/s) step pulses/s maximale Drehzahl                                    // 19200
#define SPS_LOW          3*PPS*RES     // [Ups] = (4/s) step pulses/s untere Drehzahl (unterer Wert für Stellbereich)  // 9600
#if CPU/(SPS_MIN) > 65535    // check
#error "Dieser Wert muss immer kleiner 65536 sein. Sonst Prescale Wert ändern"
#endif  

#define ACCEL            1    // Beschleunigung in sps je Rückruf. Höherer Wert beschleunigt schneller
// Gesamtzeit für n Schritte = Summe(CPU/(SPS_MIN+i*ACCEL)) mit i aus (0...n-1)
// mit der gegebenen Voreinstellung und ACCEL=4 -> 1.15s. Mit ACCEL=3 -> 1.5s

#endif
