// drive.h

#ifndef DRIVE_H
#define DRIVE_H
#include <arduino.h>
#include "StepperV1.h"
#include "defines.h"

class Drive
{
private:
  StepperV1* motor1;
  StepperV1* motor2;

public:
  bool enable, stopping;
  unsigned int sps_soll, sps, ticks; 
  byte divisor;  

public:
  Drive(int x_Step_Pin, int x_Dir_Pin, int x_Enable_Pin,int y_Step_Pin, int y_Dir_Pin, int y_Enable_Pin );
  ~Drive();
  void Start();
  void Stop();
  void SetSpeed(unsigned int);
  void OneStep();
  unsigned int GetDrvTicks();

private:
  void Enable();
  void Disable();
};
#endif
